use std::collections::HashSet;

use crate::utils::input_reader;

pub fn part_one() -> String {
    if let Ok(lines) = input_reader::read_lines("./input/2023/day_04/input.txt") {
        let mut result = 0;

        for line in lines {
            result += process_line(&line.unwrap());
        }

        result.to_string()
    } else {
        panic!("Failed to read lines from input file");
    }
}

fn process_line(s: &str) -> u32 {

    let mut winning_numbers = HashSet::new();
    let mut res = 0;

    let nums_str: Vec<&str> = s.split(':').collect::<Vec<&str>>()[1].split('|').collect();

    let w_str = nums_str[0].trim().split_whitespace().collect::<Vec<&str>>();
    let w_nums: Vec<u32> = w_str.iter().map(|s| s.parse::<u32>().unwrap()).collect();

    for n in w_nums {
        winning_numbers.insert(n);
    }

    let b_str = nums_str[1].trim().split_whitespace().collect::<Vec<&str>>();
    let b_nums: Vec<u32> = b_str.iter().map(|s| s.parse::<u32>().unwrap()).collect();

    for n in b_nums {
        if winning_numbers.contains(&n) {
            if res == 0 {
                res = 1;
            } else {
                res *= 2;
            }
        }
    }

    return res;
}


